<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class SetUserQRCode
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function curlGet($url)
    {
        $curl = curl_init(); // 启动一个CURL会话
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, true);  // 从证书中检查SSL加密算法是否存在
        $tmpInfo = curl_exec($curl);     //返回api的json对象
        //关闭URL请求
        curl_close($curl);
        return $tmpInfo;    //返回json对象
    }

    public function curlPost($url, $data)
    {
        $curl = curl_init(); // 启动一个CURL会话
        curl_setopt($curl, CURLOPT_URL, $url); // 要访问的地址
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1); // 从证书中检查SSL加密算法是否存在
        curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); // 模拟用户使用的浏览器
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1); // 使用自动跳转
        curl_setopt($curl, CURLOPT_AUTOREFERER, 1); // 自动设置Referer
        curl_setopt($curl, CURLOPT_POST, 1); // 发送一个常规的Post请求
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data); // Post提交的数据包
        curl_setopt($curl, CURLOPT_TIMEOUT, 30); // 设置超时限制防止死循环
        curl_setopt($curl, CURLOPT_HEADER, 0); // 显示返回的Header区域内容
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回
        $tmpInfo = curl_exec($curl); // 执行操作
        if (curl_errno($curl)) {
            echo 'Errno' . curl_error($curl); //捕抓异常
        }
        curl_close($curl); // 关闭CURL会话
        return $tmpInfo; // 返回数据
    }

    public function getAccessToken()
    {
        // access_token 应该全局存储与更新，以下代码以写入到文件中做示例
        $data = json_decode(file_get_contents("../data/access_token.json"));
        if (empty($data) || $data->expire_time < time()) {
            $params['grant_type'] = "client_credential";
            $params['appid'] = APPID;
            $params['secret'] = APPSECRET;
            $url = "https://api.weixin.qq.com/cgi-bin/stable_token";
            $res = json_decode($this->curlPost($url, json_encode($params)));
            $access_token = isset($res->access_token) ? $res->access_token : NULL;
            if ($access_token) {
                $res->expire_time = time() + 7000;
                $res->access_token = $access_token;
                $fp = fopen("../data/access_token.json", "w");
                fwrite($fp, json_encode($res));
                fclose($fp);
            }
        } else {
            $access_token = $data->access_token;
        }
        return $access_token;
    }

    public function setQRCode($openid, $host)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        //获取accessToken
        $accessToken = $this->getAccessToken();
        //请求腾讯接口生成小程序码
        $params['scene'] = urldecode('oid=' . $openid);
        $params['width'] = 280;
        $params['env_version'] = "trial";
        $url = "https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=" . $accessToken;
        $res = $this->curlPost($url, json_encode($params));
        //保存图片
        try {
            $savePath = "upload/qrcode/" . $openid . "_" . time() . ".png";
            $mini_code_img = dirname(dirname(__FILE__)) . "/" . $savePath;
            file_put_contents($mini_code_img, $res, true);
            //写库
            $qrcodeUrl = urldecode($host) . $savePath;
            $updateArr = array(
                'qrcodeUrl' => $qrcodeUrl
            );
            $where = "`openid`='" . $openid . "'";
            $this->pdo->update("user_info", $updateArr, $where);
            $result = array(
                'state' => 1,
                'qrcodeUrl' => $qrcodeUrl,
                'msg' => 'get success'
            );
            return $result;
        } catch (Exception $e) {
            echo $result;
        }
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
$host = isset($_REQUEST["host"]) ? $_REQUEST["host"] : "";
if (empty($openid)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$info = new SetUserQRCode($pdo);
$signPackage = $info->setQRCode($openid, $host);
$result = json_encode($signPackage);
echo $result;
