<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class TagInfo
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function setInfo($openid, $oid, $tagType, $force)
    {
        $result = array(
            'state' => 1,
            'msg' => 'get'
        );
        $time = date('Y-m-d H:i:s') . "";
        $result["getTime"] = $time;
        //查询打标人的用户信息
        $usr = $this->pdo->prepareSql("select * from user_info where openid =?");
        $usr->bindParam(1, $openid);
        $usr->execute();
        $usrData = $usr->fetchAll(PDO::FETCH_ASSOC)[0];
        $insertArr = array(
            'openid' => $openid,
            'oid' => $oid,
            'nickName' => $usrData["nickName"],
            'avatarUrl' => $usrData["avatarUrl"],
            'tagType' => $tagType,
            'tagTime' => $time
        );
        //查询是否已有评论
        $st = $this->pdo->prepareSql("select * from tags_info where openid =? and oid =?");
        $st->bindParam(1, $openid);
        $st->bindParam(2, $oid);
        $st->execute();
        $data2 = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        //
        if ($force == 0) { //单纯是查询
            if (!empty($data2)) {
                $result['state'] = 0;
                $result['msg'] = "has data";
            } else {
                $result['state'] = 1;
                $result['msg'] = "no data";
                $result['data'] = "";
                //没评论过则返回TA的昵称和头像
                $data3 = $this->getInfoByOpenid($oid);
                $result['data'] = $data3;
            }
            return $result;
        } else {
            if (!empty($data2)) {
                if (!empty($force)) { //强制更新
                    $this->forceUpdate($openid, $oid, $tagType);
                    $result['state'] = 1;
                    $result['msg'] = "update success";
                } else {
                    $result['state'] = 0;
                    $result['msg'] = "has data";
                    $result['data'] = $data2;
                }
            } else {
                //插入数据
                $this->pdo->insert("tags_info", $insertArr);
                //给被点赞用户的commentCnt+1
                $this->updateCommentCnt($oid);
                $result['state'] = 1;
                $result['msg'] = "set success";
            }
        }
        return $result;
    }

    public function getInfoByOpenid($openid)
    {
        $st = $this->pdo->prepareSql("select id,openid,avatarUrl,nickName,score from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        return $data;
    }

    public function forceUpdate($openid, $oid, $tagType)
    {
        $updateArr = array(
            'tagType' => $tagType
        );
        $where = "`openid`='" . $openid . "'" . " and `oid`='" . $oid . "'";
        $this->pdo->update("tags_info", $updateArr, $where);
    }

    public function updateCommentCnt($openid)
    {
        $st = $this->pdo->prepareSql("select * from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        if (!empty($data)) { //更新
            if (!empty($data["commentCnt"])) {
                $commentCnt = $data["commentCnt"] + 1;
            } else {
                $commentCnt = 1;
            }
            $updateArr = array(
                'commentCnt' => $commentCnt
            );
            $where = "`openid`='" . $openid . "'";
            $this->pdo->update("user_info", $updateArr, $where);
        }
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
$oid = isset($_REQUEST["oid"]) ? $_REQUEST["oid"] : "";
$tagType = isset($_REQUEST["tagType"]) ? $_REQUEST["tagType"] : "";
$force = isset($_REQUEST["force"]) ? $_REQUEST["force"] : 1; //是否强制更新

if (empty($openid) || empty($oid)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$tagInfo = new TagInfo($pdo);
$signPackage = $tagInfo->setInfo($openid, $oid, $tagType, $force);
$result = json_encode($signPackage);
echo $result;
