(function () {
    window.alert = function (name) {
        var iframe = document.createElement("IFRAME");
        iframe.style.display = "none";
        iframe.setAttribute("src", 'data:text/plain');
        document.documentElement.appendChild(iframe);
        window.frames[0].window.alert(name);
        iframe.parentNode.removeChild(iframe);
    }
})();
/** @expose */
canChangePage = true;
/** @expose */
var mainGame;
/** @expose */
var GC = GC || {};
GC.isBack = false;
//
GC.setUserInfo = "api/setUserInfo.php";
GC.getUserInfo = "api/getUserInfo.php";
GC.updateUser = "api/updateUser.php";
GC.getTags = "api/getTags.php";
GC.setTags = "api/setTags.php";
GC.sentPulsarMsg = "api/sentMsg.php";
GC.fonts = "SSO"; //Arial
GC.isDebug = false;

var herfObj = DTools.util.hrefToObj();
//神策埋点代码
var sensors = window['sensorsDataAnalytic201505'];
GC.sensors = sensors;
sensors.init({
    server_url: 'https://ds.zhaopin.cn/sa?project=production',
    is_track_single_page: true, // 单页面配置，默认开启，若页面中有锚点设计，需要将该配置删除，否则触发锚点会多触发 $pageview 事件
    use_client_time: true,
    send_type: 'beacon',
    show_log: herfObj && herfObj["showLog"] ? true : false,
    heatmap: {
        //是否开启点击图，default 表示开启，自动采集 $WebClick 事件，可以设置 'not_collect' 表示关闭。
        clickmap: 'default',
        //是否开启触达图，not_collect 表示关闭，不会自动采集 $WebStay 事件，可以设置 'default' 表示开启。
        scroll_notice_map: 'not_collect'
    }
});
sensors.quick('autoTrack');
//百度埋点代码
var _hmt = _hmt || [];
(function () {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?10c8aafc2bb3063e803429eb16a611a1";
    var s = document.getElementsByTagName("script")[0];
    s.parentNode.insertBefore(hm, s);
})();

//
var deviceWidth = document.documentElement.clientWidth;
if (deviceWidth > 750) deviceWidth = 750;
document.documentElement.style.fontSize = deviceWidth / 7.5 + 'px';
GC.pageId = 0;
GC.isAndroid = DTools.ua.android;
GC.isNotice = false; //NoticeJs专用判断显示参数
GC.appid = "99a0b758e7a344e988a02e6c5d51acf4"; //Passport业务ID
//用户基础信息
GC.at = DTools.util.getCookie("at") || '';
GC.rt = DTools.util.getCookie("rt") || '';
GC.isLogin = DTools.util.getCookie("isLogin") || ''; //是否登录跳转回来的
GC.openid = DTools.util.getCookie("openid") || '123456';
GC.nickname = decodeURIComponent(DTools.util.getCookie("nickname")) || 'duefox';
GC.headPic = DTools.util.getCookie("headimgurl") || './res/div/head.jpg'; //头像
GC.qrcodeUrl = "./res/div/qrcode.png";
GC.score = 0; //score
GC.infoData = null; //活动基本信息
GC.isFromShare = false; //是否来自分享
GC.isFirstTimeAnswer = true; //是否第一次答题
GC.tagDataArr = []; //用户标签
GC.cbk = 0;
GC.config = {};

console.log("GC.at:", GC.at, "GC.rt:", GC.rt, "GC.cbk:", GC.cbk);
if (herfObj) {
    console.log(herfObj);
    GC.oid = herfObj["oid"];
    GC.token = herfObj["token"] || "notoken";
    //是否显示loading页 空表示正常加载，具体数字表示隐藏加载条并且跳转到页面索引
    if (herfObj["cbk"]) {
        GC.cbk = herfObj["cbk"];
    } else {
        GC.cbk = "";
    }
    if (GC.oid && GC.oid != 'undefined' && GC.oid != GC.openid) { //通过朋友邀请进入的用户，并且不是自己
        GC.cbk = 4;
        GC.isFromShare = true;
    }
}
//神策关联openid
sensors.login(GC.openid);
//这里可以监听到浏览器的返回事件
window.onpopstate = function (event) {
    // var screenObj = DTools.screen.screenSize();
    // cc.log(JSON.stringify(screenObj));
    GC.isBack = true;
};
//
Zepto(function ($) {
    //开始
    cc.game.onStart = function () {
        if (GC.openid == "") return;
        if (!cc.sys.isNative && document.getElementById("warp")) {
            document.body.removeChild(document.getElementById("warp"));
        }
        cc.view.setOrientation(cc.ORIENTATION_PORTRAIT);
        if (cc.sys.isMobile) {
            cc.view.setDesignResolutionSize(750, 1514, cc.ResolutionPolicy.FIXED_WIDTH);
            cc.view.enableRetina(true);
        } else {
            cc.view.setDesignResolutionSize(750, 1514, cc.ResolutionPolicy.SHOW_ALL);
            cc.view.enableRetina(cc.sys.os === cc.sys.OS_IOS ? true : false);
        }
        cc.view.adjustViewPort(true);
        cc.view.resizeWithBrowserSize(true);
        //更新屏幕size
        GC.setWapSize();
        //加载配置
        $.ajax({
            type: "GET",
            url: './data/config.json?v=' + GC.ver,
            dataType: "json",
            success: function (data) {
                GC.config = data;
                GC.host = GC.config.host;
                showPage();
            }
        });
        //显示页面
        function showPage() {
            GC.initShareInfo(); //初始化自定义分享
            //load resources
            LoaderQuery.preload(resources, GC.cbk, function () {
                //预加载的页面都隐藏了
                $(".mod").hide();
                $(".canvasDiv").css({
                    "z-index": 0
                });
                // return;
                var errTime = 0;
                setUserInfo();
                //数据写库
                function setUserInfo() {
                    $.ajax({
                        type: "POST",
                        url: GC.setUserInfo,
                        data: {
                            "openid": GC.openid,
                            "token": GC.token,
                            "headimgurl": encodeURIComponent(GC.headPic),
                            "nickname": encodeURIComponent(GC.nickname),
                            "at": GC.at,
                            "rt": GC.rt
                        },
                        dataType: "json",
                        success: function (response) {
                            GC.infoData = response;
                            GC.setUsrInfo(response["data"]);
                            //是否第一次答题
                            if (response["data"]["score"] && parseInt(response["data"]["score"]) > 0) {
                                GC.isFirstTimeAnswer = false;
                            } else {
                                GC.isFirstTimeAnswer = true;
                            }
                            //开启画面
                            initLayer();
                        },
                        error: function () {
                            cc.log("用户基础信息获取失败,出错次数：" + errTime);
                            // if (errTime < 1) {
                            //     setUserInfo();
                            // }
                            // errTime++;
                        }
                    });
                }
                // initLayer();
                //
                function initLayer() {
                    var MyScene = cc.Scene.extend({
                        onEnter: function () {
                            this._super();
                            cc.spriteFrameCache.addSpriteFrames(res.common_plist);
                            cc.spriteFrameCache.addSpriteFrames(res.quest_plist);
                            var layer = new MainLayer();
                            this.addChild(layer, 1, 1);
                        }
                    });
                    var scene = new MyScene();
                    cc.director.runScene(scene);
                }
            }, this);
        };
    }
    cc.game.run();
});

GC.setWapSize = function () {
    var screenObj = DTools.screen.screenSize();
    GC.SIZE = cc.winSize;
    cc.log(JSON.stringify(screenObj), "GC.SIZE:", GC.SIZE);
    GC.w = GC.SIZE.width;
    GC.h = GC.SIZE.height;
    GC.w_2 = GC.SIZE.width * 0.5;
    GC.h_2 = GC.SIZE.height * 0.5;
    GC.easeDT = 0.3;
    GC.isPop = false;
    GC.biggerOffsetY = 0;
    GC.biggerOffsetY2 = 0;
    GC.smallerOffsetY = 0;
    GC.isBigger = screenObj['size'] == 1 ? true : false;
    GC.isSmaller = screenObj['size'] == 2 ? true : false;
    GC.scale = 0.9;
    if (GC.isSmaller) {
        GC.scale = 0.68;
        GC.smallerOffsetY = -50;
        GC.biggerOffsetY = 0;
    }
    if (GC.isBigger) {
        GC.scale = 1;
        var bgHeight = GC.h * GC.w / 750;
        var bgOffsetY = (bgHeight - 1334) * 0.5;
        GC.biggerOffsetY = bgOffsetY;
        GC.biggerOffsetY2 = bgOffsetY * 0.5;
        GC.smallerOffsetY = 0;
    } else {
        GC.scale = 0.92;
    }
}

//合成海报
var isMaking = false;
GC.gotoMakePhoto = function (bgRes, hexColor) {
    // cc.log("make photo");
    // cc.log(GC.w, GC.h);
    if (isMaking) return;
    isMaking = true;
    var codeURL = GC.host + "?oid=" + GC.openid + "#poster";
    var qrcodeWD = 280;
    var qrcode = new QRCode("qrcode", {
        text: codeURL,
        width: qrcodeWD,
        height: qrcodeWD,
        colorDark: "#000000",
        colorLight: "#ffffff",
        correctLevel: QRCode.CorrectLevel.M
    });
    GC.qrcodeUrl = qrcode.getImgByBase64();
    //
    var bgHeight = GC.h * GC.w / 750;
    var bgOffsetY = (bgHeight - 1334) * 0.25;
    bgOffsetY = bgOffsetY > 0 ? bgOffsetY : bgOffsetY * 3;
    var list = [{
            src: bgRes,
            x: 0,
            y: -bgOffsetY,
            w: 750,
            h: bgHeight
        },
        {
            src: "./res/div/logo3.png?v=" + GC.ver,
            x: 0,
            y: 50,
            w: 552,
            h: 82
        },
        {
            src: "./res/div/blank.png?v=" + GC.ver,
            x: 70,
            y: 1088,
            w: 155,
            h: 150
        },
        {
            src: GC.qrcodeUrl,
            x: 78,
            y: 1096,
            w: 136,
            h: 136
        },
        {
            src: "./res/div/qrcodeBox.png?v=" + GC.ver,
            x: 60,
            y: 1060,
            w: 636,
            h: 200
        }

    ];
    MakePhoto.setSize(750, 1334, hexColor);
    MakePhoto.addImg(list, function () {
        try {
            var src = MakePhoto.build('image/png');
            $('.saveImg').attr('src', src);
        } catch (e) {}
        $(".screen-end").show();
        isMaking = false;
    });
}

//设置用户基本信息
GC.setUsrInfo = function (response) {
    var usrData = response;
    GC.infoData = usrData;
    GC.nickname = usrData["nickName"];
    GC.openid = usrData["openid"];
    if (!DTools.util.isLocalNet()) {
        GC.headPic = usrData["avatarUrl"];
    }
    if (usrData["score"] && parseInt(usrData["score"]) > 0) { //已测试过的用户
        GC.score = parseInt(usrData["score"]);
    }
}

GC.updateData = false;
//更新用户信息
GC.updateUserInfo = function (openid, para, cbk) {
    if (GC.updateData) return;
    GC.updateData = true;
    $.ajax({
        type: "POST",
        url: GC.updateUser,
        data: {
            "openid": openid,
            "para": JSON.stringify(para)
        },
        dataType: "json",
        success: function (response) {
            if (response["state"] == 1) { //刷新当前用户数据
                GC.setUsrInfo(response["data"]);
            }
            if (cbk) {
                cbk(response["state"]);
            }
            GC.updateData = false;
        },
        error: function () {
            if (cbk) {
                cbk(0);
            }
            GC.updateData = false;
        }
    });
}

//获取用户标签
GC.getTag = function (openid, cbk) {
    $.ajax({
        type: "POST",
        url: GC.getTags,
        data: {
            "openid": openid
        },
        dataType: "json",
        success: function (response) {
            if (cbk) {
                cbk(response);
            }
        }
    });
}

//获取用户标签
GC.setTag = function (openid, oid, force, cbk, tagType = "") {
    $.ajax({
        type: "POST",
        url: GC.setTags,
        data: {
            "openid": openid,
            "oid": oid,
            "force": force,
            "tagType": tagType
        },
        dataType: "json",
        success: function (response) {
            if (cbk) {
                cbk(response);
            }
        }
    });
}

//发送pulsar消息
GC.SentPulsarMsg = function (topicId) {
    $.ajax({
        type: "POST",
        url: GC.sentPulsarMsg,
        data: {
            "at": GC.at,
            "topicId": topicId
        },
        dataType: "json",
        success: function (response) {
            console.log(response);
        }
    });
}


//是否在微信或者微信小程序内函数
function isWx() {
    var ua = navigator.userAgent.toLowerCase();
    if (ua.match(/MicroMessenger/i) == "micromessenger") {
        return new Promise(resolve => {
            wx.miniProgram.getEnv(function (res) {
                if (res.miniprogram) {
                    resolve("mini-wx");
                } else {
                    resolve("wx");
                }
            });
        });
    } else {
        // console.log("不在微信里");
        return new Promise(resolve => {
            resolve("no-wx");
        });
    }
}

// num传入的数字，n需要的字符长度
function prefixInteger(num, n) {
    return (Array(n).join(0) + num).slice(-n);
}

//zepto没有scrollTo动画，这里扩展了一个scrollTo函数
$.fn.scrollTo = function (options) {
    var defaults = {
        scrollTop: 0, //滚动目标位置
        durTime: 500, //过渡动画时间
        delay: 30, //定时器时间
        callback: null //回调函数
    };
    var opts = $.extend(defaults, options),
        timer = null,
        that = this,
        curTop = that.scrollTop(), //滚动条当前的位置
        subTop = opts.scrollTop - curTop, //滚动条目标位置和当前位置的差值
        index = 0,
        dur = Math.round(opts.durTime / opts.delay),
        smoothScroll = function (t) {
            index++;
            var per = Math.round(subTop / dur);
            if (index >= dur) {
                that.scrollTop(t);
                window.clearInterval(timer);
                if (opts.callback && typeof opts.callback == 'function') {
                    opts.callback();
                }
                return;
            } else {
                that.scrollTop(curTop + index * per);
            }
        };
    timer = window.setInterval(function () {
        smoothScroll(opts.scrollTop);
    }, opts.delay);
    return that;
};

//敏感词判断
function filterWords(text) {
    if (filterArr.index(text) != -1) {
        return true;
    }
    for (var i = 0, len = filterArr.length; i < len; i++) {
        var str = filterArr[i];
        if (text.indexOf("" + str) > -1) {
            //str中包含字符串
            return true;
        }
    }
    return false;
}

//按字节长度截取字符串，返回截取的字符串
function cutString(str, leng) {
    var len = str.length,
        tlen = len,
        nlen = 0;
    for (var x = 0; x < len; x++) {
        if (str.charCodeAt(x) > 128) {
            if (nlen + 2 < leng) {
                nlen += 2;
            } else {
                tlen = x;
                break;
            }
        } else {
            if (nlen + 1 < leng) {
                nlen += 1;
            } else {
                tlen = x;
                break;
            }
        }
    }
    return str.substring(0, tlen);
}

//好友点赞列表
GC.showMoreFrendsPage = function () {
    // cc.log("showMoreFrendsPage");
    $(".frendList").empty();
    var htmlText = '';
    for (var i = 0, len = GC.tagDataArr.length; i < len; i++) {
        var tagData = GC.tagDataArr[i];
        var headPic = tagData["avatarUrl"];
        var nickName = tagData["nickName"];
        var tagsArr = tagData["tagType"].split(",");
        //
        htmlText += '<div class="itemBox">' +
            '<div class="itemContent"><div class="headBox tagBox"><div class="head">' +
            '<img class="radiusImg" src="' + headPic + '"></div>' +
            '<div class="nameBox"><p>' + nickName + '</p></div></div>' +
            '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[0] + '.png"></div></div>' +
            '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[1] + '.png"></div></div>' +
            '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[2] + '.png"></div></div>' +
            '</div></div>';
    }
    $(".frendList").append(htmlText);
    $(".screen-frend").show();
    //
    GC.sensorsTrack("superPageClick", {
        pageName: "pageTags",
        buttonName: "btnMoreTags"
    });
}

//跳转小程序
GC.toMiniPragram = function (jumpStr) {
    var jumpArr = ["getBonus", "btnXue", "btnMai", "btnDang"];
    var index = jumpArr.index(jumpStr);
    if (index == 0) {
        GC.sensorsTrack("superPageClick", {
            pageName: "pageResult",
            buttonName: "btnGetBonus"
        });
    } else if (index == 1) {
        GC.sensorsTrack("superPageClick", {
            pageName: "pageResult",
            buttonName: "btnXue"
        });
    } else if (index == 2) {
        GC.sensorsTrack("superPageClick", {
            pageName: "pageResult",
            buttonName: "btnMai"
        });
    } else if (index == 3) {
        GC.sensorsTrack("superPageClick", {
            pageName: "pageResult",
            buttonName: "btnDang"
        });
    }
    //
    var appid = GC.config["transferInfo"][index]["appid"];
    var path = GC.config["transferInfo"][index]["path"];
    if (jumpStr == "getBonus") { //抽奖额外给path加参数
        // path += "&at=" + GC.at + "&rt=" + GC.rt + "&openid=" + GC.openid;
        path += "?recall=" + encodeURIComponent(GC.host + "?cbk=0");
    }
    var jumpType = GC.config["transferInfo"][index]["jumpType"];
    cc.log("跳转路径：", path);
    isWx().then(type => {
        if (type == "mini-wx") {
            if (jumpType == "webview") {
                var miniUrl = '/pages/transferPage/transfer?appid=' + appid + '&jumpType=' + jumpType + '&path=' + encodeURIComponent(path);
            } else {
                var miniUrl = '/pages/transferPage/transfer?appid=' + appid + '&jumpType=' + jumpType + '&path=/' + encodeURIComponent(path);
            }
            cc.log("URL:", miniUrl);
            wx.miniProgram.navigateTo({
                url: miniUrl
            });
        } else {
            if (jumpType == "webview") {
                cc.log("ios:", DTools.ua.ios);
                const url = new URL(location);
                url.searchParams.set("cbk", 0);
                history.pushState({}, "", url);
                window.location.href = path;
                //
                // if (DTools.ua.ios) {
                //     history.pushState({}, "");
                //     window.location.href = path;
                //     // window.location.replace(path);
                // } else {
                //     history.pushState({}, "");
                //     window.location.href = path;
                // }
            } else {
                window.location.href = "weixin://dl/business/?appid=" + appid + "&path=" + path;
            }
        }
    });
}

//设置分享信息
GC.initShareInfo = function () {
    cc.log("initShareInfo");
    // 分享
    var shareLink = GC.host;
    var shareImg = "https://m.zhaopin.com/dongpeng/dakatest/res/sharePic.jpg";
    var shareDesc = "出门在外，身份都是自己给的";
    var sTitle = "有奖测试| 你是职场中的什么咖";
    if (DTools.ua.weixin) {
        if (typeof JLDSDK != 'undefined') {
            JLDSDK.config({
                "debug": false, //调试模式
                "imgUrl": shareImg, //分享图片的地址
                "link": shareLink, //分享的进入地址
                "desc": shareDesc,
                "timeLine": sTitle,
                "title": sTitle,
                "hmt": function (arg) {
                    $('.shareContent').fadeOut();
                    GC.sensorsTrack("superPageWXShareClick", {
                        pageName: "wxNativeInterface",
                        buttonName: "btnWXShare"
                    });
                    //发送pulsar消息
                    GC.SentPulsarMsg(1);
                    //更新抽奖按钮图片
                    GC.updateGetBonusPic();
                }
            });
        }
    }
}

//更新分享
GC.updateShareInfo = function () {
    cc.log("updateShareInfo");
    // 分享更新
    var shareLink = GC.host + "?oid=" + GC.openid;
    var shareImg = "https://m.zhaopin.com/dongpeng/dakatest/res/sharePic.jpg";
    var shareDesc = "为TA贴上大咖标签，赢互动好礼";
    var sTitle = "你眼中的" + GC.nickname + "是个什么咖？";
    if (DTools.ua.weixin) {
        if (typeof JLDSDK != 'undefined') {
            JLDSDK.update({
                "debug": false, //调试模式
                "imgUrl": shareImg, //分享图片的地址
                "link": shareLink, //分享的进入地址
                "desc": shareDesc,
                "timeLine": sTitle,
                "title": sTitle,
                "hmt": function (arg) {
                    console.log(arg);
                    $('.shareContent').fadeOut();
                    GC.sensorsTrack("superPageWXShareClick", {
                        pageName: "wxNativeInterface",
                        buttonName: "btnWXShare"
                    });
                    //发送pulsar消息
                    GC.SentPulsarMsg(1);
                    //更新抽奖按钮图片
                    GC.updateGetBonusPic();
                }
            });
        }
    }
}

//分享回调
GC.updateGetBonusPic = function () {
    mainGame.changeGetBonusPic();
}

//神策打点
GC.sensorsTrack = function (evtName, obj) {
    // cc.log(evtName, obj);
    //_hmt.push(['_trackEvent', category, action, opt_label, opt_value]);
    if (typeof _hmt != 'undefined') {
        var action = obj["enterType"] || obj["buttonName"] || obj['resultName'] || "click";
        var opt_label = obj["questIndex"] || obj["tagIndex"];
        if (action && opt_label) {
            _hmt.push([evtName, obj['pageName'], action, opt_label]);
        } else if (action && !opt_label) {
            _hmt.push([evtName, obj['pageName'], action]);
        } else {
            _hmt.push([evtName, obj['pageName']]);
        }
    }
    //属性全部转为小写
    var objStr = JSON.stringify(obj).toLowerCase();
    var sentObj = JSON.parse(objStr);
    sentObj.passport_at = GC.at;
    sentObj.passport_rt = GC.rt;
    sentObj.appid = "wx447d319c808d7290";
    GC.sensors.track(evtName, sentObj);
}

var hash = location.href.substring(location.href.indexOf("#") + 1);
console.log("hash:", hash);
if (hash && hash == "poster") { //埋点扫码进入的
    GC.sensorsTrack("superPageLoad", {
        pageName: "pageLoad",
        enterType: "fromPoster"
    });
} else if (GC.isFromShare) {
    GC.sensorsTrack("superPageLoad", {
        pageName: "pageLoad",
        enterType: "fromInvite"
    });
} else if (GC.cbk == 2) {
    GC.sensorsTrack("superPageLoad", {
        pageName: "pageLoad",
        enterType: "fromBonus"
    });
} else {
    GC.sensorsTrack("superPageLoad", {
        pageName: "pageLoad",
        enterType: "fromNormal"
    });
}