var JLDSDK = JLDSDK || {};
JLDSDK = (function () {
    var confgURL = "//m.zhaopin.com/dongpeng/dakatest/oauth/wxapi/cfg.php";
    var cfg = {
        "debug": false,
        "imgUrl": '"https://m.zhaopin.com/dongpeng/dakatest/res/sharePic.jpg"', //分享图片的地址
        "link": 'https://m.zhaopin.com/dongpeng/dakatest/', //分享的进入地址
        "desc": 'JLDSDK分享标题',
        "timeLine": '朋友圈分享文案',
        "title": "JLDSDK分享描述",
        "hmt": null
    };
    //Ajax
    var ajax = {
        get: function (url, fn) {
            var obj = new XMLHttpRequest(); // XMLHttpRequest对象用于在后台与服务器交换数据
            obj.open('GET', url, true);
            obj.onreadystatechange = function () {
                if (obj.readyState == 4 && obj.status == 200 || obj.status == 304) { // readyState == 4说明请求已完成
                    fn.call(this, obj.responseText); //从服务器获得数据
                }
            };
            obj.send();
        },
        post: function (url, data, fn) { // data应为'a=a1&b=b1'这种字符串格式，在jq里如果data为对象会自动将对象转成这种字符串格式
            var obj = new XMLHttpRequest();
            obj.open("POST", url, true);
            obj.setRequestHeader("Content-type", "application/x-www-form-urlencoded"); // 添加http头，发送信息至服务器时内容编码类型
            obj.onreadystatechange = function () {
                if (obj.readyState == 4 && (obj.status == 200 || obj.status == 304)) { // 304未修改
                    fn.call(this, obj.responseText);
                }
            };
            obj.send(data);
        }
    };

    //浏览器信息
    JLDSDK.phone = {
        app: function () {
            var userAgent = navigator.userAgent;
            if (userAgent.indexOf("MicroMessenger") > -1) {
                return "wx";
            } else {
                return "other";
            }
        },
        system: function () {
            var userAgent = navigator.userAgent;
            if (userAgent.indexOf("Android") > -1) {
                return "Android";
            } else if (userAgent.indexOf("iPhone") > -1) {
                return "iPhone";
            } else if (userAgent.indexOf("iPad") > -1) {
                return "iPad";
            } else {
                return "Pc";
            }
        }
    };

    JLDSDK.update = function (setData) {
        if (setData) {
            cfg['debug'] = setData['debug'] || cfg['debug'];
            cfg['imgUrl'] = setData['imgUrl'] || cfg['imgUrl'];
            cfg['link'] = setData['link'] || cfg['link'];
            cfg['desc'] = setData['desc'] || cfg['desc'];
            cfg['timeLine'] = setData['timeLine'] || cfg['timeLine'];
            cfg['title'] = setData['title'] || cfg['title'];
            cfg['hmt'] = setData['hmt'] || cfg['hmt'];
        }
    };

    JLDSDK.pushEvent = function (evtName) {
        if (cfg.hmt) {
            cfg.hmt(evtName);
        }
    };

    JLDSDK.config = function (setData) {
        JLDSDK.update(setData);
        //获取微信参数
        var url = encodeURIComponent(window.location.href.split('#')[0]);
        ajax.get(
            confgURL + "?url=" + url,
            function (arg) {
                console.log(arg);
                arg = JSON.parse(arg);
                wx.config({
                    debug: cfg['debug'],
                    appId: arg["appId"],
                    timestamp: arg["timestamp"],
                    nonceStr: arg["nonceStr"],
                    signature: arg["signature"],
                    jsApiList: [
                        'checkJsApi',
                        'onMenuShareTimeline',
                        'onMenuShareAppMessage'
                    ],
                    openTagList: [
                        'wx-open-launch-weapp', //跳转小程序
                        'wx-open-launch-app' //跳转app
                    ]
                });
                wxConfig();
            });

        function wxConfig() {
            wx.ready(function () {
                wx.checkJsApi({
                    jsApiList: [
                        'checkJsApi',
                        'onMenuShareTimeline',
                        'onMenuShareAppMessage'
                    ],
                    success: function (res) {

                    }
                });

                //好友
                wx.onMenuShareAppMessage({
                    title: cfg.title,
                    desc: cfg.desc,
                    link: cfg.link,
                    imgUrl: cfg.imgUrl,
                    trigger: function (res) {
                        this.desc = cfg.desc;
                        this.title = cfg.title;
                        this.link = cfg.link;
                        this.imgUrl = cfg.imgUrl;
                    },
                    success: function (res) {
                        JLDSDK.pushEvent("shareAppMessage");
                    },
                    cancel: function (res) {

                    },
                    fail: function (res) {

                    }
                });
                //朋友圈
                wx.onMenuShareTimeline({
                    title: cfg.timeLine,
                    desc: cfg.timeLine,
                    link: cfg.link,
                    imgUrl: cfg.imgUrl,
                    trigger: function (res) {
                        this.desc = cfg.timeLine;
                        this.title = cfg.timeLine;
                        this.link = cfg.link;
                        this.imgUrl = cfg.imgUrl;
                    },
                    success: function (res) {
                        JLDSDK.pushEvent("shareTimeline");
                    },
                    cancel: function (res) {

                    },
                    fail: function (res) {

                    }
                });
                //
                wx.error(function (res) {

                });
            });
        }
    };

    return {
        config: JLDSDK.config,
        update: JLDSDK.update,
        pushEvent: JLDSDK.pushEvent,
        phone: JLDSDK.phone
    }
})();

;
document.getElementById = (function (fn) {
    return function () {
        return fn.apply(document, arguments);
    };
})(document.getElementById);