LoaderQuery = cc.Scene.extend({
    _dt: null,
    cb: null,
    cbk: null,
    loadPro: null,
    loadText: null,
    loadIcon: null,
    loadIcon2: null,
    showLoad: true,

    init: function (showLoad) {
        if ((showLoad == "" || showLoad == 4) && !GC.isBack) {
            this.showLoad = true;
        } else {
            this.showLoad = false;
        }
        cc.log("showLoad:", this.showLoad, "isBack:", GC.isBack, "GC.cbk:", GC.cbk);
        GC.mainLoad = this;
        this._dt = new Date().getTime();
        var bg = new cc.LayerColor(cc.color(255, 255, 255, 255));
        this.addChild(bg, 0, 0);
        this.initLoad();
        return true;
    },

    initLoad: function () {
        var that = this;
        var res2 = {
            loadBG_png: "res/loadBG.png?v=" + GC.ver,
            logo_png: "res/logo.png?v=" + GC.ver,
            load_plist: "res/load.plist?v=" + GC.ver,
            load_png: "res/load.png?v=" + GC.ver
        };
        var resources2 = [];
        for (var i in res2) {
            resources2.push(res2[i]);
        }

        cc.loader.load(resources2, function (err, results) {
            if (err) {
                return;
            }
            cc.spriteFrameCache.addSpriteFrames(res2.load_plist);
            that.initFrameAnimate("loadIcon_000", 8, 6);
            //
            if (that.showLoad) {
                var mainBG = new cc.Sprite(res2.loadBG_png);
                mainBG.x = GC.w_2;
                mainBG.y = GC.h_2;
                that.addChild(mainBG, 0, 0);
                var logo = new cc.Sprite(res2.logo_png);
                logo.anchorX = 0;
                logo.x = 0;
                logo.y = GC.h_2 + 550 + GC.biggerOffsetY;
                that.addChild(logo, 9, 9);
                //
                var loadIcon = new cc.Sprite("#loadIcon_00000.png");
                var act = new cc.Animate(cc.animationCache.getAnimation("loadIcon_000"));
                loadIcon.runAction(act.repeatForever());
                loadIcon.x = GC.w_2;
                loadIcon.y = GC.h_2 + loadIcon.height * 0.5 + 110;
                that.addChild(loadIcon, 1, 1);
                var loadText = new cc.Sprite("#loadText.png");
                loadText.x = GC.w_2;
                loadText.y = GC.h_2 - loadText.height * 0.5 - 60;
                that.addChild(loadText, 10, 10);
                loadText.runAction(cc.sequence(
                    cc.scaleTo(0.3, 1.06).easing(cc.easeSineOut()),
                    cc.delayTime(0.1),
                    cc.scaleTo(0.3, 1).easing(cc.easeSineOut())
                ).repeatForever());
                //
                var loadBar = new cc.Sprite("#loadBar.png");
                loadBar.x = GC.w_2;
                loadBar.y = GC.h_2 + 40;
                that.addChild(loadBar, 11, 11);
                //
                var loadPro = new cc.ProgressTimer(new cc.Sprite("#loadPro.png"));
                loadPro.x = loadBar.x;
                loadPro.y = loadBar.y;
                that.addChild(loadPro, 12, 12);
                loadPro.type = cc.ProgressTimer.TYPE_BAR;
                loadPro.midPoint = cc.p(0, 1);
                loadPro.barChangeRate = cc.p(1, 0);
                that.loadPro = loadPro;
                //默认Arial字体
                var precentText = new cc.LabelTTF('0%', 'SSO', 28, cc.size(GC.w_2, 46), cc.TEXT_ALIGNMENT_CENTER, cc.TEXT_ALIGNMENT_CENTER);
                precentText.x = GC.w_2;
                precentText.y = loadBar.y - 60;
                precentText.color = cc.color(0, 0, 0);
                precentText.enableStroke(cc.color(0, 0, 0), 1);
                that.addChild(precentText, 16, 16);
                that.loadText = precentText;
            } else {

            }
        });
    },

    onEnter: function () {
        var that = this;
        cc.Node.prototype.onEnter.call(that);
        that.schedule(that._startLoading, 0.1);
    },
    onExit: function () {
        cc.Node.prototype.onExit.call(this);
    },

    initWithResources: function (resources, cb) {
        if (cc.isString(resources))
            resources = [resources];
        this.resources = resources || [];
        this.cb = cb;
    },

    initFrameAnimate: function (flag, cnt, fps) {
        if (!fps) {
            fps = cnt;
        }
        var animFrames = [],
            str = "",
            frame;
        for (var i = 0; i < cnt; i++) {
            str = flag + (i < 10 ? ("0" + i) : i) + ".png";
            frame = cc.spriteFrameCache.getSpriteFrame(str);
            animFrames.push(frame);
        }
        var animation = new cc.Animation(animFrames, 1 / fps);
        cc.animationCache.addAnimation(animation, flag);
        return new cc.Sprite("#" + flag + "00.png");
    },

    _startLoading: function () {
        var that = this;
        that.unschedule(that._startLoading);
        var res = that.resources;
        var rate = 1;
        if (this.showLoad) {
            rate = 0.9;
        }
        cc.loader.load(res,
            function (result, count, loadedCount) {
                var percent = Math.ceil((loadedCount + 1) / count * 100) * rate;
                // cc.log(percent);
                if (this.showLoad) {
                    if (percent >= 18) {
                        percent = 20;
                        that.gotoDelayLoad();
                        return;
                    }
                }
                that.setPercent(percent);
            },
            function () {
                if (that.showLoad) {
                    that.gotoDelayLoad();
                } else {
                    that.resLoadOverHandler();
                }
            });
    },

    gotoDelayLoad: function () {
        if (GC.intVal) return;
        var that = this;
        var percent = GC.percent > 20 ? GC.percent : 20;
        GC.intVal = setInterval(function () {
            percent += 7;
            if (percent >= 100) {
                clearInterval(GC.intVal);
                percent = 99;
                that.resLoadOverHandler();
            }
            that.setPercent(percent);
        }, 200);
    },

    setPercent: function (percent) {
        try {
            if (!percent) {
                return;
            }
            GC.percent = percent;
            if (GC.mainLoad.loadPro) {
                GC.mainLoad.loadPro.percentage = percent;
            }
            if (percent > 99) {
                percent = 99;
            }
            if (this.showLoad) {
                this.loadText.setString(parseInt(percent) + "%");
            }
        } catch (e) {
            // cc.log(e, this.loadPro, percent);
        }
    },

    resLoadOverHandler: function () {
        if (this.cb) {
            this.cb();
        }
    }
});

LoaderQuery.preload = function (resources, showLoad, cb) {
    var _cc = cc;
    if (!_cc.loaderScene) {
        _cc.loaderScene = new LoaderQuery();
        _cc.loaderScene.init(showLoad);
    }
    _cc.loaderScene.initWithResources(resources, cb);
    cc.director.runScene(_cc.loaderScene);
    return _cc.loaderScene;
};