//PageHome
var PageHome = PageLayer.extend({
    mainBG: null,
    canTouch: false,

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        mainGame.showQuickIcon([0]);
        mainGame.showLogo(false);
        this.initUI();
        //
        GC.sensorsTrack("superPageLoad", {
            pageName: "pageHome"
        });
        return true;
    },

    initUI: function () {
        var mainBG = new cc.Sprite(res.bg00_png);
        mainBG.x = GC.w_2;
        mainBG.y = GC.h_2;
        this.addChild(mainBG, 0, 0);
        //
        var topBar = new cc.Sprite("#topBar.png");
        topBar.x = GC.w_2;
        topBar.y = GC.h_2 + 550;
        this.addChild(topBar, 1000, 1000);
        var downBar = new cc.Sprite("#downBar.png");
        downBar.x = GC.w_2;
        downBar.y = GC.h_2 - 585;
        this.addChild(downBar, 1001, 1001);
        //跑马灯效果
        var topTextScroll = new TextScroll("#text00.png", 4, 30, 42, -1);
        topTextScroll.x = 0;
        topTextScroll.y = topBar.height * 0.5 - 25;
        topBar.addChild(topTextScroll, 0, 0);
        topTextScroll.runRepeat();
        var downTextScroll = new TextScroll("#text01.png", 4, 30, -15, 1);
        downTextScroll.x = -383;
        downTextScroll.y = downBar.height * 0.5 + 28;
        downBar.addChild(downTextScroll, 0, 0);
        downTextScroll.runRepeat();
        //
        var pinkEye = new cc.Sprite("#pinkEye.png");
        pinkEye.x = GC.w_2 - 200;
        pinkEye.y = GC.h_2 + 320;
        this.addChild(pinkEye, 1, 1);
        pinkEye.runAction(GC.shakeAction.repeatForever().clone());
        var star00 = new cc.Sprite("#star00.png");
        star00.x = GC.w_2 - 100;
        star00.y = GC.h_2 + 400;
        this.addChild(star00, 3, 3);
        star00.runAction(GC.shakeAction.repeatForever().clone());
        //
        var planeBox = new cc.Sprite();
        planeBox.x = 0;
        planeBox.y = 0;
        this.addChild(planeBox, 2, 2);
        var plane = new cc.Sprite("#plane.png");
        plane.x = GC.w_2 + 255;
        plane.y = GC.h_2 + 430;
        planeBox.addChild(plane, 3, 3);
        planeBox.runAction(cc.sequence(
            cc.moveTo(0.8, cc.p(0, -10)).easing(cc.easeSineIn()),
            cc.moveTo(0.8, cc.p(0, 0)).easing(cc.easeSineOut())
        ).repeatForever());
        //slogan
        // var slogan = new TextClipper(
        //     "#slogan.png",
        //     cc.p(GC.w_2 + 10, GC.h_2 + 20),
        //     "right",
        //     0.5,
        //     0
        // );
        var slogan = new cc.Sprite("#slogan.png");
        slogan.x = GC.w_2 + 10;
        slogan.y = GC.h_2 + 20;
        this.addChild(slogan, 4, 4);
        // var logo = new TextClipper(
        //     res.logo2_png,
        //     cc.p(320, GC.h_2 + 235),
        //     "left",
        //     0.5,
        //     0.3
        // );
        var logo = new cc.Sprite(res.logo2_png);
        logo.x = 320;
        logo.y = GC.h_2 + 235;
        this.addChild(logo, 5, 5);
        //
        var icon00 = new cc.Sprite("#icon00.png");
        icon00.anchorY = 0;
        icon00.x = GC.w_2 - 200;
        icon00.y = GC.h_2 - 440 - icon00.height * 0.5;
        icon00.scaleY = 0.8;
        // icon00.opacity = 0;
        this.addChild(icon00, 6, 6);
        // icon00.runAction(cc.sequence(
        //     cc.spawn(
        //         cc.fadeIn(0.2),
        //         cc.scaleTo(0.2, 1, 1).easing(cc.easeBackOut())
        //     )
        // ));
        var icon01 = new cc.Sprite("#icon01.png");
        icon01.anchorY = 0;
        icon01.x = GC.w_2 - 270;
        icon01.y = GC.h_2 - 440 - icon01.height * 0.5;
        icon01.scaleY = 0.8;
        // icon01.opacity = 0;
        this.addChild(icon01, 7, 7);
        // icon01.runAction(cc.sequence(
        //     cc.delayTime(0.2),
        //     cc.spawn(
        //         cc.fadeIn(0.2),
        //         cc.scaleTo(0.2, 1, 1).easing(cc.easeBackOut())
        //     )
        // ));
        var text02 = new cc.Sprite("#text02.png");
        text02.x = GC.w_2 - 230;
        text02.y = GC.h_2 - 110;
        // text02.opacity = 0;
        this.addChild(text02, 10, 10);
        // text02.runAction(cc.sequence(
        //     cc.delayTime(0.8),
        //     cc.fadeIn(0.4)
        // ));
        var eyes = new cc.Sprite("#eyes.png");
        eyes.x = 10;
        eyes.y = 40;
        // eyes.opacity = 0;
        text02.addChild(eyes);
        eyes.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(0.15, 1, 0),
                cc.fadeIn(0.15)
            ),
            cc.scaleTo(0.15, 1),
            cc.delayTime(1)
        ).repeatForever());
        var bottle = new cc.Sprite("#bottle.png");
        bottle.x = GC.w_2 + 260;
        bottle.y = GC.h_2 - 380;
        var angle = 2;
        bottle.rotation = angle;
        this.addChild(bottle, 11, 11);
        bottle.runAction(cc.sequence(
            cc.delayTime(2.5),
            cc.spawn(
                cc.rotateTo(0.5, -angle).easing(cc.easeSineOut()),
                cc.scaleTo(0.5, 1.06).easing(cc.easeSineOut())
            ),
            cc.spawn(
                cc.rotateTo(0.5, angle).easing(cc.easeSineOut()),
                cc.scaleTo(0.5, 1).easing(cc.easeSineOut())
            )
        ).repeatForever());
        var coffee00 = new cc.Sprite("#coffee00.png");
        coffee00.x = GC.w_2 + 120;
        coffee00.y = GC.h_2 - 435;
        this.addChild(coffee00, 12, 12);
        var coffee01 = new cc.Sprite("#coffee01.png");
        coffee01.x = GC.w_2 + 280;
        coffee01.y = GC.h_2 - 510;
        this.addChild(coffee01, 13, 13);
        var star01 = new cc.Sprite("#star01.png");
        star01.x = GC.w_2 + 170;
        star01.y = GC.h_2 - 340;
        this.addChild(star01, 14, 14);
        star01.runAction(GC.shakeAction.repeatForever().clone());
        //
        // this.scheduleOnce(this.showMenu, 0.2);
        this.showMenu();
    },

    showMenu: function () {
        var menuRes = ["#btnStart.png"];
        var menuPosArr = [cc.p(GC.w_2, GC.h_2 - 160 - GC.biggerOffsetY)];
        var menuArr = [];
        //
        for (var i = 0, len = menuRes.length; i < len; i++) {
            var itemMenu = new cc.MenuItemImage(menuRes[i]);
            itemMenu.tid = i;
            itemMenu.opacity = 0;
            itemMenu.setPosition(menuPosArr[i]);
            itemMenu.setCallback(this.onTouchStart.bind(this), this);
            menuArr[i] = itemMenu;
        }
        itemMenu.runAction(GC.tipsAction2.clone());

        var menu = new cc.Menu();
        menu.initWithArray(menuArr);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 1999, 1999);
    },

    onTouchStart: function (sender) {
        DTools.soundAudio.play("touchAudio");
        //
        GC.sensorsTrack("superPageClick", {
            pageName: "pageHome"
        });
        if (GC.at != "" && GC.rt != "") {
            GC.pageId = 1;
            mainGame.changePage(0);
        } else { //跳转智联登录页,并且回调到答题页
            mainGame.nopasspott(1);
        }

        // isWx().then(type => {
        //     if (type == "mini-wx") {
        //         cc.log("微信小程序环境中");
        //         //假如url参数jwt=0则跳转到授权登录页，否则游戏继续
        //         if (GC.jwt == 0) { //跳回小程序授权页
        //             var url = encodeURIComponent("/pages/main/main?oid=" + GC.oid);
        //             var miniUrl = '/pages/login/login?sourcePath=' + url;
        //             cc.log("URL:", miniUrl);
        //             wx.miniProgram.navigateTo({
        //                 url: miniUrl
        //             });
        //         } else {
        //             GC.pageId = 1;
        //             mainGame.changePage(0);
        //         }
        //     } else {
        //         GC.pageId = 1;
        //         mainGame.changePage(0);
        //     }
        // });

    },
});
//
var PageQuest = PageLayer.extend({
    questBox: null,
    menuRes: null,
    menuArr: null,
    menu: null,
    crtChecked: null,
    questId: 0,

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        mainGame.showQuickIcon([0]);
        mainGame.showLogo(true);
        mainGame.showArrow(false);
        this.questId = 0;
        this.initUI();
        return true;
    },

    initUI: function () {
        var mainBG = new cc.Sprite(res.bg01_png);
        mainBG.x = GC.w_2;
        mainBG.y = GC.h_2;
        this.addChild(mainBG, 0, 0);
        //quest box
        var questBox = new cc.Sprite("#questBox.png");
        questBox.x = GC.w_2 - 10;
        questBox.y = GC.h_2 + 200 + GC.biggerOffsetY;
        questBox.scale = GC.scale;
        this.addChild(questBox, 9, 9);
        this.questBox = questBox;
        //
        this.initQuest();
    },

    initQuest: function () {
        GC.sensorsTrack("superPageLoad", {
            pageName: "pageContent",
            questIndex: this.questId
        });
        this.clearMenu();
        //
        if (this.questBox) {
            this.questBox.removeAllChildren();
        }
        var search = new cc.Sprite("#search.png");
        search.x = this.questBox.width - 30;
        search.y = this.questBox.height - 24;
        this.questBox.addChild(search, 0, 0);
        search.runAction(GC.shakeAction.repeatForever().clone());
        var dotSprite = new DotSprite();
        dotSprite.x = 30;
        dotSprite.y = this.questBox.height - 24;
        this.questBox.addChild(dotSprite, 1, 1);
        //
        var man = new cc.Sprite(res["man0" + this.questId + "_png"]);
        man.anchorX = 0;
        man.anchorY = 0;
        man.x = 5;
        man.y = 2;
        man.scale = GC.scale;
        // man.opacity = 0;
        // man.runAction(cc.fadeIn(0.2));
        this.questBox.addChild(man, 0, 0);
        var questText = new cc.Sprite("#" + questArr[this.questId]["quest"]);
        questText.anchorX = 0;
        questText.x = 200;
        questText.y = 185;
        // questText.scaleY = 0;
        // questText.opacity = 0;
        this.questBox.addChild(questText, 1, 1);
        // questText.runAction(cc.sequence(
        //     cc.delayTime(0.1),
        //     cc.spawn(
        //         cc.scaleTo(0.1, 1).easing(cc.easeBackOut()),
        //         cc.fadeIn(0.1)
        //     )
        // ));
        //答案
        // this.scheduleOnce(this.showMenu, 0.2);
        this.showMenu();
    },

    clearMenu: function () {
        if (this.menu) {
            this.menu.removeFromParent(true);
        }
        this.menuRes = [];
        this.menuArr = [];
    },

    showMenu: function () {
        var menuRes = ["#btnNext.png"];
        if (this.questId == questArr.length - 1) {
            menuRes = ["#btnResult.png"];
        }
        for (var j = 0, cnt = questArr[this.questId]["score"].length; j < cnt; j++) {
            var btnRes = "#answer" + this.questId + "" + j + ".png";
            menuRes.push(btnRes);
        }
        this.menuRes = menuRes;
        var menuPosArr = [
            [
                cc.p(GC.w_2 - 225, GC.h_2 - 180),
                cc.p(GC.w_2 - 10, GC.h_2 - 180),
                cc.p(GC.w_2 + 205, GC.h_2 - 180)
            ],
            [
                cc.p(GC.w_2 - 10, GC.h_2 - 70),
                cc.p(GC.w_2 - 180, GC.h_2 - 290),
                cc.p(GC.w_2 + 160, GC.h_2 - 290)
            ],
            [
                cc.p(GC.w_2 - 180, GC.h_2 - 70),
                cc.p(GC.w_2 + 160, GC.h_2 - 70),
                cc.p(GC.w_2 - 180, GC.h_2 - 290),
                cc.p(GC.w_2 + 160, GC.h_2 - 290)
            ]
        ];
        var menuArr = [];
        this.menuArr = menuArr;
        //
        for (var i = 0, len = menuRes.length; i < len; i++) {
            var normalSprite = new cc.Sprite(menuRes[i]);
            var answerChecked = new cc.Sprite("#answerChecked.png");
            answerChecked.x = 150;
            answerChecked.y = normalSprite.height - 45;
            answerChecked.visible = false;
            normalSprite.addChild(answerChecked, 0, 0);
            var selectedSprite = new cc.Sprite(menuRes[i]);
            selectedSprite.scale = 0.98;
            var itemMenu = new cc.MenuItemSprite(normalSprite, selectedSprite);
            itemMenu.tid = i;
            itemMenu.scale = GC.scale;
            itemMenu.checkedIcon = answerChecked;
            // itemMenu.opacity = 0;
            if (i == 0) {
                itemMenu.setPosition(cc.p(GC.w - 60 - itemMenu.width * 0.5, GC.h_2 - 480));
                itemMenu.visible = false;
            } else {
                itemMenu.setPosition(menuPosArr[questArr[this.questId]["type"]][i - 1]);
            }
            itemMenu.setCallback(this.onTouchStart.bind(this), this);
            menuArr[i] = itemMenu;
        }
        if (this.questId == questArr.length - 1) {
            this.menuArr[0].runAction(GC.tipsAction3.clone());
        }
        //
        var menu = new cc.Menu();
        menu.initWithArray(menuArr);
        menu.x = 0;
        menu.y = -30;
        this.menu = menu;
        this.addChild(menu, 1999, 1999);
    },

    onTouchStart: function (sender) {
        DTools.soundAudio.play("touchAudio");
        // cc.log(sender.tid);
        if (sender.tid == 0) { //下一题
            this.conutscore();
            this.crtChecked = null;
            //
            if (this.questId == questArr.length - 1) { //查看测试结果
                //更新得分
                var para = {
                    score: GC.score
                };
                GC.updateUserInfo(GC.openid, para, function () {
                    DTools.util.setCookie("scoreResult", GC.score);
                    GC.pageId = 2;
                    mainGame.changePage(0);
                });
                GC.sensorsTrack("superPageClick", {
                    pageName: "pageContent",
                    buttonName: "btnResult"
                });
                //发送pulsar消息
                GC.SentPulsarMsg(0);
            } else {
                this.showNextQuest();
            }
        } else {
            if (this.crtChecked != sender) {
                if (this.crtChecked) this.crtChecked.checkedIcon.visible = false;
                sender.checkedIcon.visible = true;
                this.crtChecked = sender;
                if (this.questId == questArr.length - 1) {
                    this.menuArr[0].visible = true;
                }
                //直接下一题
                this.scheduleOnce(this.showNextQuest, 0.2);
                //
                GC.sensorsTrack("superPageClick", {
                    pageName: "pageContent",
                    questIndex: this.questId,
                    buttonName: "answer" + answerTypeArr[sender.tid]
                });
            }
        }
    },

    showNextQuest: function () {
        cc.log("this.questId:", this.questId);
        this.conutscore(); //计算上一提的得分
        if (this.questId == questArr.length - 2) {
            this.menuArr[0].visible = true;
        }
        if (this.questId == questArr.length - 1) {
            return;
        }
        GC.sensorsTrack("superPageClick", {
            pageName: "pageContent",
            buttonName: "btnNext"
        });
        //
        this.questId++;
        this.initQuest();
    },

    conutscore: function () {
        if (!this.crtChecked) return;
        var score = questArr[this.questId]["score"][this.crtChecked.tid - 1];
        GC.score += score;
        cc.log("GC.score:", GC.score);
    }

});

//测试结果页
var PageResult = PageLayer.extend({
    bgColorArr: null,
    hexColorArr: null,
    menuArr: [],
    rid: 3,

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        this.initUI();
        return true;
    },

    initUI: function () {
        mainGame.showQuickIcon([]);
        mainGame.showArrow(false);
        this.hexColorArr = ["#fdf16b", "#aebdff", "#ffafef", "#b1ebfe"];
        this.bgColorArr = [
            cc.color(253, 241, 107, 255),
            cc.color(174, 189, 255, 255),
            cc.color(255, 175, 239, 255),
            cc.color(177, 235, 254, 255)
        ];
        GC.updateShareInfo();
        //
        var resultTypeArr = ["resultA", "resultB", "resultC", "resultD"];
        if (GC.score > 26) {
            this.rid = 0;
        } else if (GC.score > 20) {
            this.rid = 1;
        } else if (GC.score > 14) {
            this.rid = 2;
        } else {
            this.rid = 3;
        }
        cc.log("GC.score:", GC.score, " rid:", this.rid);
        //
        $(".myName").html(GC.nickname);
        $(".myHeadPic").attr("src", GC.headPic);
        $(".resultImg").attr("src", "./res/div/re0" + this.rid + ".png");
        $(".screen-end").css("background-color", this.hexColorArr[this.rid]);
        $(".screen-end").show();
        //
        GC.sensorsTrack("superPageLoad", {
            pageName: "pageResult",
            resultName: resultTypeArr[this.rid]
        });
        // cc.log("this.rid:", this.rid);
        var mainBG = new cc.LayerColor(this.bgColorArr[this.rid]);
        mainBG.x = 0;
        mainBG.y = 0;
        this.addChild(mainBG, 0, 0);
        //
        var resultRes = res["re0" + this.rid + "_png"];
        var resultText = new cc.Sprite(resultRes);
        resultText.x = GC.w_2;
        resultText.y = GC.h_2 + 95;
        this.addChild(resultText, 1, 1);
        var headBox = new cc.Sprite(res.headBox_png);
        headBox.x = 110;
        headBox.y = resultText.height - 20;
        resultText.addChild(headBox, 0, 0);
        //头像
        var that = this;
        cc.loader.loadImg(GC.headPic, {
            isCrossOrigin: true
        }, function (err, img) {
            if (err) {
                return;
            }
            var head = new HeadClipper(
                img,
                res.headMask_png,
                cc.p(72, 76),
                138, 138
            );
            headBox.addChild(head, 0, 0);
            //
            that.scheduleOnce(that.cutScreen, 0.02);
        }.bind(this));
        var nameBox = new cc.Sprite(res.nameBox_png);
        nameBox.x = headBox.width * 0.5;
        nameBox.y = 6;
        headBox.addChild(nameBox, 1, 1);
        //
        var nameText = new cc.LabelTTF(cutString(GC.nickname, 11), 'Arial', 22, cc.size(nameBox.width, 24), cc.TEXT_ALIGNMENT_CENTER, cc.TEXT_ALIGNMENT_CENTER);
        nameText.x = nameBox.width * 0.5;
        nameText.y = nameBox.height * 0.5 - 2;
        nameText.color = cc.color(0, 0, 0);
        nameBox.addChild(nameText, 0, 0);
    },

    cutScreen: function () {
        //截取当前屏幕#单屏
        var c = document.getElementById("gameCanvas");
        var tmpBase64 = c.toDataURL("image/png");
        cc.loader.loadImg(tmpBase64, {
            isCrossOrigin: false
        }, function (err, img) {
            var texture2d = new cc.Texture2D();
            texture2d.initWithElement(img);
            texture2d.handleLoadedTexture();
            var cutScreen = new cc.Sprite(texture2d);
        }.bind(this));
        //显示logo
        mainGame.showLogo(true);
        //
        var saveTips = new cc.Sprite("#saveTips.png");
        saveTips.x = GC.w - 25;
        saveTips.y = GC.h_2;
        saveTips.opacity = 0;
        this.addChild(saveTips, 3, 3);
        saveTips.runAction(cc.fadeIn(0.3));
        //显示菜单
        // this.showMenu();
        //合成海报
        GC.gotoMakePhoto(tmpBase64, this.hexColorArr[this.rid]);
        //
        // this.changeGetBonusPic();
    },

    showMenu: function () {
        var menuRes = ["#btnBonus.png", "#btnShare2.png", "#btnXue.png", "#btnMai.png", "#btnDang.png"];
        if (GC.isFirstTimeAnswer) {
            menuRes = ["#btnBonus.png", "#btnShare.png", "#btnXue.png", "#btnMai.png", "#btnDang.png"];
        }
        var menuPosArr = [
            cc.p(GC.w_2 - 160, GC.h_2 - 370),
            cc.p(GC.w_2 + 180, GC.h_2 - 370),
            cc.p(GC.w_2 - 225, GC.h_2 - 550),
            cc.p(GC.w_2 + 2, GC.h_2 - 550),
            cc.p(GC.w_2 + 230, GC.h_2 - 550)
        ];
        var menuArr = [];
        //
        for (var i = 0, len = menuRes.length; i < len; i++) {
            var normalSprite = new cc.Sprite(menuRes[i]);
            var selectedSprite = new cc.Sprite(menuRes[i]);
            selectedSprite.scale = 0.98;
            var itemMenu = new cc.MenuItemSprite(normalSprite, selectedSprite);
            itemMenu.tid = i;
            itemMenu.opacity = 0;
            itemMenu.setPosition(menuPosArr[i]);
            itemMenu.setCallback(this.onTouchStart.bind(this), this);
            menuArr[i] = itemMenu;
        }
        var act1 = cc.sequence(
            cc.spawn(
                cc.scaleTo(0.5, 0.9).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 255)
            ),
            cc.spawn(
                cc.scaleTo(0.5, 1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 240)
            )
        ).repeatForever();
        var act2 = cc.sequence(
            cc.spawn(
                cc.scaleTo(0.5, 1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 240)
            ),
            cc.spawn(
                cc.scaleTo(0.5, 0.9).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 255)
            )
        ).repeatForever();
        menuArr[0].scale = 1;
        // menuArr[1].scale = 0.9;
        menuArr[0].runAction(act1);
        // menuArr[1].runAction(act2);
        for (var j = 1, len2 = menuArr.length; j < len2; j++) {
            menuArr[j].opacity = 255;
            // menuArr[j].scale = 1.1;
            // menuArr[j].runAction(cc.sequence(
            //     cc.delayTime(0.3 * j),
            //     cc.spawn(
            //         cc.fadeIn(0.3).easing(cc.easeSineOut()),
            //         cc.scaleTo(0.3, 1).easing(cc.easeSineOut())
            //     )
            // ));
        }
        this.menuArr = menuArr;
        var menu = new cc.Menu();
        menu.initWithArray(menuArr);
        menu.x = 0;
        menu.y = -20;
        this.addChild(menu, 1999, 1999);
    },

    onTouchStart: function (sender) {
        DTools.soundAudio.play("touchAudio");
        // cc.log(sender.tid);
        if (sender.tid == 0) { //抽奖
            GC.toMiniPragram("getBonus");
        } else if (sender.tid == 1) { //分享
            $('.shareContent').show();
        } else if (sender.tid == 2) { //学大咖
            GC.toMiniPragram("btnXue");
        } else if (sender.tid == 3) { //买大咖
            GC.toMiniPragram("btnMai");
        } else if (sender.tid == 4) { //当大咖
            GC.toMiniPragram("btnDang");
        }
    },

    //改变分享按钮的图片
    changeGetBonusPic: function () {
        if (this.menuArr[0]) {
            cc.log("changeGetBonusPic");
            var sp1 = new cc.Sprite(res.btnBonus2_png);
            var sp2 = new cc.Sprite(res.btnBonus2_png);
            this.menuArr[0].setNormalImage(sp1);
            this.menuArr[0].setDisabledImage(sp2);
        }
    },
});

//本人标签页
var PageTag = PageLayer.extend({
    tagDataArr: [],
    rid: 3,
    headRes: {},

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        this.initUI();
        return true;
    },

    initUI: function () {
        mainGame.showQuickIcon([]);
        mainGame.showLogo(false);
        mainGame.showArrow(false);
        GC.updateShareInfo();
        this.hexColorArr = ["#fdf16b", "#aebdff", "#ffafef", "#b1ebfe"];
        if (GC.score > 26) {
            this.rid = 0;
        } else if (GC.score > 20) {
            this.rid = 1;
        } else if (GC.score > 14) {
            this.rid = 2;
        } else {
            this.rid = 3;
        }
        $(".screen-tags").css("background-color", this.hexColorArr[this.rid]);
        //标签box
        this.getTags();
        GC.sensorsTrack("superPageLoad", {
            pageName: "pageTags"
        });
    },

    getTags: function () {
        var that = this;
        //网络读取标签数据
        GC.getTag(GC.openid, function (arg) {
            if (arg["state"] == 1 && arg["data"]) {
                that.tagDataArr = arg["data"];
                GC.tagDataArr = arg["data"];
                that.showFrendTags();
                that.showMoreTags();
                $(".screen-tags").show();
                that.showBigTags();
            } else {
                GC.pageId = 2;
                mainGame.changePage(0);
            }
        });

    },

    showMoreTags: function () {
        if (GC.tagDataArr.length > 1) {
            $(".moreFrendBox").show();
        } else {
            return;
        }
        $(".moreContent").empty();
        var htmlText = '';
        for (var i = 0, len = 2; i < len; i++) {
            var tagData = GC.tagDataArr[i];
            var headPic = tagData["avatarUrl"];
            var nickName = tagData["nickName"];
            htmlText += '<div class="moreItemBox"><div class="headBox tagBox"><div class="head"><img class="radiusImg" src="' + headPic + '"></div>' +
                '<div class="nameBox"><p>' + nickName + '</p></div></div></div>';
        }
        $(".moreContent").append(htmlText);
    },

    //显示页面上的好友
    showFrendTags: function () {
        if (GC.tagDataArr.length > 1) {
            $(".moreFrendBox").show();
        }
        //本人
        $(".myName").html(GC.nickname);
        $(".myHeadPic").attr("src", GC.headPic);
        //列表1
        $(".frendBox").empty();
        var htmlText = '';
        for (var i = 0, len = GC.tagDataArr.length; i < len; i++) {
            var tagData = GC.tagDataArr[i];
            var headPic = tagData["avatarUrl"];
            var nickName = tagData["nickName"];
            var tagsArr = tagData["tagType"].split(",");
            //
            htmlText += '<div class="frendItemBox">' +
                '<div class="frendContent"><div class="headBox tagBox"><div class="head">' +
                '<img class="radiusImg" src="' + headPic + '"></div>' +
                '<div class="nameBox"><p>' + nickName + '</p></div></div>' +
                '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[0] + '.png"></div></div>' +
                '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[1] + '.png"></div></div>' +
                '<div class="tagBox"><div class="tagImg"><img src="./res/tags/tag0' + tagsArr[2] + '.png"></div></div>' +
                '</div></div>';
        }
        $(".frendBox").append(htmlText);
        $(".frendItemBox").css('display', 'none');
        $(".frendItemBox").eq(0).css('display', 'block');
        var id = 0;
        this.schedule(function () {
            $(".frendItemBox").eq(id).css('display', 'none');
            id++;
            if (id > len - 1) {
                id = 0;
            }
            $(".frendItemBox").eq(id).css('display', 'block');
        }, 2.5);
    },

    showBigTags: function () {
        //默认判断最大的标签
        if (GC.score > 26) {
            this.rid = 0;
        } else if (GC.score > 20) {
            this.rid = 1;
        } else if (GC.score > 14) {
            this.rid = 2;
        } else {
            this.rid = 3;
        }
        //统计标签个数
        // var styleTypeArr = [0, 4, 3, 3, 3, 2, 0, 2, 0, 2, 4, 4];
        var styleTypeArr = [0, 4, 3, 2, 2, 3, 0, 2, 0, 2, 4, 4];
        // styleTypeArr = styleTypeArr.shuffle();
        var tagsTypeArr = this.countTags();
        $(".tagsList").empty();
        var htmlText = '<div class="mainTag tagType"><div><img src="./res/tags/resultTag' + this.rid + '.png"></div></div>';
        for (var i = 0, len = tagsTypeArr.length; i < len; i++) {
            var typeData = tagsTypeArr[i];
            var cnt = typeData["cnt"];
            if (cnt == 0) {
                break;
            } else {
                var type = typeData["type"];
                htmlText += '<div class="tagType' + styleTypeArr[i] + ' tagType"><div class="tagCnt"><p>' + cnt + '票</p></div><div><img src="./res/tags/type' + type + '' + styleTypeArr[i] + '.png"></div></div>';
            }
        }
        //修改tagsList的grid-template-rows: 1.3rem 1.3rem 1.3rem 1.3rem 1.3rem;值
        if (i < 5) {
            $(".tagsList").css("grid-template-rows", "1.3rem 1.3rem 1.3rem");
            $(".swapTips").css("display", "none");
        }
        $(".tagsList").append(htmlText);
    },

    countTags: function () {
        var tmpArr = [];
        for (var i = 0, len = this.tagDataArr.length; i < len; i++) {
            var tagsArr = this.tagDataArr[i]["tagType"].split(",");
            tmpArr = tmpArr.concat(tagsArr);
        }
        var typeArr = [];
        for (var j = 0; j < 10; j++) {
            var obj = {
                type: j,
                cnt: 0
            };
            typeArr[j] = obj;
        }
        //
        for (var x = 0, len2 = tmpArr.length; x < len2; x++) {
            var type = parseInt(tmpArr[x]);
            typeArr[type]["cnt"]++;
        }
        //排序
        typeArr.sort(sortBy('cnt', -1));
        return typeArr;
        //attr：根据该属性排序；rev：升序1或降序-1，不填则默认为1
        function sortBy(attr, rev) {
            if (rev == undefined) {
                rev = 1
            } else {
                (rev) ? 1: -1;
            }
            return function (a, b) {
                a = a[attr];
                b = b[attr];
                if (a < b) {
                    return rev * -1
                }
                if (a > b) {
                    return rev * 1
                }
                return 0;
            }
        }
    }
});


//邀请页
var PageInvite = PageLayer.extend({
    chooseBox: null,
    bgColorArr: null,
    hexColorArr: null,
    menuArr: [],
    checkedMenuArr: [], //选好的标签
    checkCnt: 3, //需要选中的标签数量
    rid: 3,
    nickname: '',
    headPic: '',

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        mainGame.showQuickIcon([]);
        mainGame.showLogo(true);
        mainGame.showArrow(false);
        //先请求数据看看是否已经评论了
        this.initData();
        return true;
    },

    initData: function () {
        var that = this;
        //先查询是否评论过了，并且返回ta的头像和昵称
        GC.setTag(GC.openid, GC.oid, 0, function (arg) {
            if (arg["state"] == 0) { //直接去用户本人页
                cc.log("已评论过此用户！");
                if (GC.score && GC.score > 0) { //已测试过的用户
                    //分俩种情况：1：没评论去结果页，2：有评论去查看标签页
                    if (GC.infoData["commentCnt"]) {
                        GC.pageId = 3;
                    } else {
                        GC.pageId = 2;
                    }
                } else {
                    GC.pageId = 0;
                }
                mainGame.changePage(0);
            } else { //得到TA的用户昵称和头像
                cc.log(arg);
                if (arg["data"] && arg["data"] != null) {
                    that.nickname = arg["data"]["nickName"] || "null";
                    that.headPic = arg["data"]["avatarUrl"] || "./res/div/head.jpg";
                    that.initUI();
                } else {
                    if (GC.score && GC.score > 0) { //已测试过的用户
                        //分俩种情况：1：没评论去结果页，2：有评论去查看标签页
                        if (GC.infoData["commentCnt"]) {
                            GC.pageId = 3;
                        } else {
                            GC.pageId = 2;
                        }
                    } else {
                        GC.pageId = 0;
                    }
                    mainGame.changePage(0);
                }
            }
        });
    },

    initUI: function () {
        GC.sensorsTrack("superPageLoad", {
            pageName: "pageInvite"
        });
        if (GC.score > 26) {
            this.rid = 0;
        } else if (GC.score > 20) {
            this.rid = 1;
        } else if (GC.score > 14) {
            this.rid = 2;
        } else {
            this.rid = 3;
        }
        // cc.log("this.rid:", this.rid);
        var mainBG = new cc.Sprite(res.bg02_png);
        mainBG.x = 0;
        mainBG.y = 0;
        this.addChild(mainBG, 0, 0);
        var star00 = new cc.Sprite("#star04.png");
        star00.x = GC.w_2 + 300;
        star00.y = GC.h_2 + 520;
        this.addChild(star00, 1, 1);
        star00.runAction(GC.shakeAction.repeatForever().clone());
        var resultBox = new cc.Sprite("#resultBox.png");
        resultBox.x = GC.w_2;
        resultBox.y = GC.h_2 + 350;
        this.addChild(resultBox, 1, 1);
        //
        var resultRes = ("#result0" + this.rid + ".png");
        var resultText = new cc.Sprite(resultRes);
        resultText.x = resultBox.width * 0.5 + 50;
        resultText.y = resultBox.height * 0.5 - 20;;
        resultBox.addChild(resultText, 0, 0);
        var dir = new cc.Sprite("#dir.png");
        dir.x = 85;
        dir.y = resultText.height - 130;
        dir.opacity = 0;
        resultBox.addChild(dir, 2, 2);
        dir.runAction(GC.tipsAction3.clone());
        var headBox = new cc.Sprite(res.headBox_png);
        headBox.x = 90;
        headBox.y = resultText.height - 20;
        headBox.scale = 0.8;
        resultBox.addChild(headBox, 1, 1);
        //头像
        var that = this;
        cc.loader.loadImg(this.headPic, {
            isCrossOrigin: true
        }, function (err, img) {
            if (err) {
                return;
            }
            var head = new HeadClipper(
                img,
                res.headMask_png,
                cc.p(72, 76),
                138, 138
            );
            headBox.addChild(head, 0, 0);
        }.bind(this));
        var nameBox = new cc.Sprite(res.nameBox_png);
        nameBox.x = headBox.width * 0.5;
        nameBox.y = 6;
        headBox.addChild(nameBox, 1, 1);
        //
        var nameText = new cc.LabelTTF(cutString(this.nickname, 11), 'Arial', 22, cc.size(nameBox.width, 24), cc.TEXT_ALIGNMENT_CENTER, cc.TEXT_ALIGNMENT_CENTER);
        nameText.x = nameBox.width * 0.5;
        nameText.y = nameBox.height * 0.5 - 2;
        nameText.color = cc.color(0, 0, 0);
        nameBox.addChild(nameText, 0, 0);
        //
        var chooseBox = new cc.Sprite("#chooseBox.png");
        chooseBox.x = GC.w_2;
        chooseBox.y = GC.h_2 - 160;
        this.addChild(chooseBox, 2, 2);
        var search = new cc.Sprite("#search.png");
        search.x = chooseBox.width - 50;
        search.y = chooseBox.height - 26;
        chooseBox.addChild(search, 0, 0);
        this.chooseBox = chooseBox;
        search.runAction(GC.shakeAction.repeatForever().clone());
        //
        var bottle = new cc.Sprite("#bottle.png");
        bottle.x = chooseBox.width - 112;
        bottle.y = chooseBox.height - 100;
        bottle.scale = 0.5;
        chooseBox.addChild(bottle, 11, 11);
        //
        this.showMenu(chooseBox);

    },

    showMenu: function (chooseBox) {
        var menuRes = ["#choose00.png", "#choose01.png", "#choose02.png", "#choose03.png", "#choose04.png", "#choose05.png", "#choose06.png", "#choose07.png", "#choose08.png", "#choose09.png", "#btnChoosed.png", "#btnTest.png"];
        var menuPosArr = [
            cc.p(chooseBox.width * 0.5 - 20, chooseBox.height * 0.5 - 120),
            cc.p(chooseBox.width * 0.5 - 220, chooseBox.height * 0.5 + 40),
            cc.p(chooseBox.width * 0.5 - 110, chooseBox.height * 0.5 - 40),
            cc.p(chooseBox.width * 0.5 - 220, chooseBox.height * 0.5 - 120),
            cc.p(chooseBox.width * 0.5 + 180, chooseBox.height * 0.5 + 50),
            cc.p(chooseBox.width * 0.5 + 130, chooseBox.height * 0.5 - 40),
            cc.p(chooseBox.width * 0.5 + 120, chooseBox.height * 0.5 - 210),
            cc.p(chooseBox.width * 0.5 - 140, chooseBox.height * 0.5 - 210),
            cc.p(chooseBox.width * 0.5 - 30, chooseBox.height * 0.5 + 50),
            cc.p(chooseBox.width * 0.5 + 190, chooseBox.height * 0.5 - 120),
            cc.p(chooseBox.width * 0.5, chooseBox.height * 0.5 - 320),
            cc.p(chooseBox.width * 0.5, chooseBox.height * 0.5 - 450)
        ];
        var menuArr = [];
        //
        for (var i = 0, len = menuRes.length; i < len; i++) {
            //0-9是逻辑按钮
            if (i < 10) {
                var menuOn = new cc.MenuItemImage(menuRes[i]);
                var menuOff = new cc.MenuItemImage(menuRes[i]);
                menuOff.scale = 0.9;
                var check = new cc.Sprite("#answerChecked.png");
                check.x = 20;
                check.y = menuOff.height * 0.5 + 4;
                menuOff.addChild(check, 0, 0);
                var itemMenu = new cc.MenuItemToggle(
                    menuOn,
                    menuOff
                );
            } else {
                var normalSprite = new cc.Sprite(menuRes[i]);
                var selectedSprite = new cc.Sprite(menuRes[i]);
                selectedSprite.scale = 0.98;
                var itemMenu = new cc.MenuItemSprite(normalSprite, selectedSprite);
            }
            itemMenu.tid = i;
            itemMenu.isChecked = false; //是否被选中
            itemMenu.setPosition(menuPosArr[i]);
            itemMenu.setCallback(this.onTouchStart.bind(this), this);
            menuArr[i] = itemMenu;
        }
        this.menuArr = menuArr;
        var len = menuArr.length;
        menuArr[len - 2].runAction(GC.tipsAction3.clone());
        // menuArr[len - 1].runAction(GC.shakeAction.repeatForever().clone());
        var menu = new cc.Menu();
        menu.initWithArray(menuArr);
        menu.x = 0;
        menu.y = 0;
        chooseBox.addChild(menu, 1999, 1999);
    },

    onTouchStart: function (sender) {
        DTools.soundAudio.play("touchAudio");
        // cc.log(sender.tid);
        if (sender.tid == 10) {
            if (this.checkedMenuArr.length == this.checkCnt) { //提交数据
                sender.enabled = false;
                this.gotoSubmitTags();
                //
                GC.sensorsTrack("superPageClick", {
                    pageName: "pageInvite",
                    buttonName: "btnSelected"
                });
            } else {
                $(".chooseTips").show();
            }
        } else if (sender.tid == 11) {
            GC.sensorsTrack("superPageClick", {
                pageName: "pageInvite",
                buttonName: "btnTestMe"
            });
            //判断是否已经测试过
            if (GC.score && GC.score > 0) {
                mainGame.nopasspott();
                //分俩种情况：1：没评论去结果页，2：有评论去查看标签页
                if (GC.infoData["commentCnt"]) {
                    GC.pageId = 3;
                } else {
                    GC.pageId = 2;
                }
            } else {
                GC.pageId = 0;
            }
            mainGame.changePage(0);
        } else {
            sender.isChecked = !sender.isChecked;
            // cc.log("isChecked:", sender.isChecked);
            if (sender.isChecked) { //放到数组
                //判断是否超了个数
                if (this.checkedMenuArr.length > this.checkCnt - 1) {
                    sender.isChecked = false;
                    sender.setSelectedIndex(0);
                    $(".chooseTips").show();
                    return;
                }
                this.checkedMenuArr.push(sender);
                //
                GC.sensorsTrack("superPageClick", {
                    pageName: "pageInvite",
                    tagIndex: sender.tid
                });
            } else { //删除数组中的
                this.checkedMenuArr.remove(sender);
            }
        }
    },

    gotoSubmitTags: function () {
        var that = this;
        var tagType = '';
        for (var i = 0, len = this.checkedMenuArr.length; i < len; i++) {
            if (i == len - 1) {
                tagType += this.checkedMenuArr[i]["tid"];
            } else {
                tagType += this.checkedMenuArr[i]["tid"] + ',';
            }
        }
        GC.setTag(GC.openid, GC.oid, 1, function (arg) {
            // if (GC.score && GC.score > 0) { //已测试过的用户
            //     GC.pageId = 2;
            // } else {
            //     GC.pageId = 0;
            // }
            // mainGame.changePage(0);
            //隐藏按钮，显示提示字
            that.menuArr[10].visible = false;
            var checkedText = new cc.Sprite(res.checkedText_png);
            checkedText.x = that.chooseBox.width * 0.5;
            checkedText.y = that.chooseBox.height * 0.5 - 285;
            that.chooseBox.addChild(checkedText, 99, 99);
            that.menuArr[11].runAction(GC.shakeAction.repeatForever().clone());
        }, tagType);
    }
});